/* ======================================================================
OBJECT:		com_netobjects_Image

DESC:			This object allows developers to create Imagees with common built
				in behaviors.

TESTED
PLATFORMS:	Netscape Navigator 4.02 or higher, 
				Microsoft Internet Explorer 4.01 or higher
====================================================================== */
function com_netobjects_FormImage(params) {
   // Public Properties	
	this.name 				= (params.name != null) ? params.name : "";
	this.imageName			= (params.imageName != null) ? params.imageName : "";
	this.formName			= (params.formName != null) ? params.formName : "";
	this.align				= (params.align != null) ? params.align : "";
	this.src					= (params.src != null) ? params.src : "";
	this.border				= ((params.border != null) && (params.border != "")) ? params.border : "0";

	this.testMode			= (params.testMode != null) ? params.testMode : "none"
	
	// Private Properties
	this.ImageIndex = 0

	// Public Methods
	this.render 			= _Image_render;

	// Private Methods
	this.validateProperties = _Image_validateProperties;

	// Public Events
	this.onBlur     	 	= _Image_onBlur;
	this.onClick 			= _Image_onClick;
	this.onFocus   		= _Image_onFocus;
	this.onRender     	= _Image_onRender;

	// Private Events (internal event driven functionality)

	// Validate object properties
	this.validateProperties();

	// Public Methods ----------------------------------------
	/* ======================================================================
	
   METHOD: _Image_render.  Renders the HTML INPUT element tag in the browser
	based on the object's property values.

	====================================================================== */
	function _Image_render() {
		// Initialize Variables
		var sImageName = "";
		var ssrc = "";
		var sborder = "";

		var sonBlur  = "";
		var sonClick = "";
		var sonFocus = "";

		// Set Variables
		sImageName 	= " Name = \"" + this.imageName + "\"";
		sborder 		= " Border = \"" + this.border + "\"";
		ssrc 			= " SRC = \"" + this.src + "\"";
		sAlign		= " ALIGN = \"" + this.align + "\"";

		// Build Nav & IE shared link events
		sonBlur  = " onBlur=\"" + this.name + ".onBlur();\"";
		sonClick   = " onClick=\"return " + this.name + ".onClick();\"";
		sonFocus    = " onFocus=\"" + this.name + ".onFocus();\"";
		eEvents  = sonBlur + sonClick + sonFocus;

		// Write HTML
	   document.write( "<Input Type=Image "  + sImageName + ssrc + sAlign + sborder + eEvents + ">\n");

		// Fire public events
		this.onRender(); 
	
	} // END _Image_render


	/* ======================================================================
	
   METHOD: _Image_validateProperties.  If the test mode is set,
	generate error and/or warning messages if required or recommended properties
	are set with invalid property values or are not set at all.

	====================================================================== */
	function _Image_validateProperties() {
		if ((this.testMode.toLowerCase() == "text") || (this.testMode.toLowerCase() == "alerts")) {
			var errors = new Array()
	      iIndex = 0;  
         
			// Check for errors
			if (this.name == "") 
				errors[iIndex++] = "Name is a required property.";  
			if (this.imageName == "") 
				errors[iIndex++] = "Image name is a required property.";  
			if (this.imageName == this.name) 
				errors[iIndex++] = "Image name and object name may not be the same.";  
 
			// Display errors
			for (var i=0; i<errors.length; i++)  {
				if (this.testMode.toLowerCase()	== "text") 
					document.write( "<BR><HR><B><FONT COLOR=RED>TEST MODE, com_netobjects_FormImage, '" + this.name + "' : </FONT> " + errors[i] + "</B><HR>\n");
				else
  					alert("TEST MODE, com_netobjects_FormImage, '" + this.name + "' : " + errors[i]);
 
			}			
		} 
	} // END _Image_validateProperties

	// Public Event Handlers ----------------------------------------
	function _Image_onBlur() {
	}
	function _Image_onClick() {
	}
	function _Image_onFocus() {
	}
	function _Image_onRender() {
	}
	
	// Private Events ----------------------------------------

} // END CONSTRUCTOR com_netobjects_Image

